/*
*  NymMail.h
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef nymmailH
#define nymmailH

#include "fileman.h"
//---------------------------------------------------------------------------
bool __fastcall HasNyms();
bool __fastcall HasActualNyms();
bool __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle);
void __fastcall NymShutDown();
char*__fastcall GetNymLibVersion();
char*__fastcall GetNymLibName();

char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode);
bool __fastcall RunNymWizard(TForm *Owner);
void __fastcall RunNymReports(TForm *Owner);
void __fastcall RunFinger(TForm *Owner);
char*__fastcall RunNymRegistry(TForm *Owner);
bool __fastcall IsNymDeleteMsg(TStrings *msg);
bool __fastcall GetNymServers(TStrings *tostrings);
char*__fastcall RunNymPGPKeyChange(TForm *Owner, char *oldkeyid);
bool __fastcall CreateKeyChangeMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename, AnsiString &newkeyid8);
// create nym config message
bool __fastcall CreateConfigMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename, bool preview);
// create nym command message
bool __fastcall CreateCommandMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename);
// create nym delete message
bool __fastcall CreateDeleteMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename);

typedef void __fastcall (*NYMINIT)(HINSTANCE, HINSTANCE, HWND);
typedef void __fastcall (*NYMSHUTDOWN)();
typedef char*__fastcall (*GET_NYMLIBVERSION)();
typedef char*__fastcall (*GET_NYMLIBNAME)();
typedef char*__fastcall (*DECRYPTNYMMESSAGE)(TForm*,char*,int&);
typedef bool __fastcall (*RUNNYMWIZARD)(TForm*);
typedef void __fastcall (*RUNNYMREPORTS)(TForm*);
typedef void __fastcall (*RUNFINGER)(TForm*);
typedef char*__fastcall (*RUNNYMREGISTRY)(TForm*);
typedef char*__fastcall (*GENREPLYBLKS)(TForm*,char*,bool);
typedef char*__fastcall (*NYMKEYCHANGE)(TForm*,char*);
typedef bool __fastcall (*CREATEKEYCHNGMSG)(TForm*, char*,char*,char*,char*,char*);
typedef bool __fastcall (*CREATENYMCFGMSG)(TForm*,char*,char*,char*,char*,bool);
typedef bool __fastcall (*CREATECFGMSG)(TForm*,char*,char*,char*,char*);

const AnsiString NymConfigHdr = "Nym-Config: ";
const AnsiString NymProfilesKey = "nyms"+PS+"profiles";    // current nym profiles
const AnsiString NymProfOldsKey = "nyms"+PS+"profolds";    // last previous profile
const AnsiString NymRetiredsKey = "nyms"+PS+"retireds";    // retired nyms
const AnsiString NymConfigsKey  = "nyms"+PS+"configs";  // last unencrypted config message
const AnsiString NymReplaysKey  = "nyms"+PS+"replays";     // last encrypted config message
const AnsiString NymRBTempsKey = "nyms"+PS+"blktemplates"; // reply block templates
const AnsiString LastNymProfileKey = "lastnymprofile";
const AnsiString NymAutoDecrypt = "nymautodecrypt";
const AnsiString NymShowIntro = "nymshowintro";

const AnsiString DefNymCmds =
   "+acksend,-signsend,+cryptrecv,-fixedsize,-disable,-nobcc,-fingerkey";
const AnsiString NymCommandsKey = "nyms"+PS+"commands"; // editable list of commands

const AnsiString CpkDirectives =
   "Reply-Block:,Anon-To:,Anon-Post-To:,Remail-To:,Latent-Time:,Encrypt-Key:";
const AnsiString CpkDirectivesKey = "Cpunk"+PS+"Directives";

const AnsiString CpkHeaders =
   "Subject:,From:,Cc:,Bcc:,Reply-To,Newsgroups:,Followup-To:,X-No-Archive:";
const AnsiString CpkHeadersKey = "Cpunk"+PS+"Headers";

const AnsiString NymServers = "nym.alias.net,redneck.gacracker.org,nym.xganon.com,";
const AnsiString NymServersKey = "nyms"+PS+"nymservers";

// this is a mode used in the GetMergeMessage function clipreply.h
const int modeNymcnfg = 2;

#define NYMSHOWINTROSET(val)  PutAppIni(NymShowIntro,val)
#define NYMSHOWINTRO         (GetAppIni(NymShowIntro,"1")=="1")
#define NYMAUTODECRYPT       (GetAppIni(NymAutoDecrypt,"1")=="1")
//---------------------------------------------------------------------------
extern HINSTANCE hNymLib;
#endif
