/*
*  QSNewsWins.h
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef QSNewsWinsH
#define QSNewsWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
//#include "NewsManDlgs.h"
//#include "NewsProfDlgs.h"
#include "NntpCli.hpp"
#include "explbtn.hpp"
#include "global.h"
//---------------------------------------------------------------------------
class TQSNntpCli : public TNntpCli
{
public:
   __fastcall TQSNntpCli(TComponent *Owner);
   void virtual __fastcall WSocketDnsLookupDone(TObject *Sender, WORD Error);
};

class TQSNewsWin : public TForm
{
__published:	// IDE-managed Components
   TPanel *Panel1;
   TTimer *Timer1;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *GetMailBtn;
        TMenuItem *N1;
        TMenuItem *Exit1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TStatusBar *StatusBar1;
        TRichEdit *DisplayMemo;
        TSpeedButton *GetBtn;
        TSpeedButton *CancelBtn;
        TBevel *Bevel1;
        TMenuItem *Tools1;
        TMenuItem *AccountManager1;
        TMenuItem *OpenHelp1;
        TSpeedButton *AccountsBtn;
        TTimer *Timer2;
        TListBox *SubList;
        TPopupMenu *PopupMenu1;
        TMenuItem *Items1;
        TMenuItem *New1;
        TMenuItem *Edit1;
        TMenuItem *View1;
        TMenuItem *N2;
        TMenuItem *Delete2;
        TMenuItem *New2;
        TMenuItem *Edit2;
        TMenuItem *View2;
        TMenuItem *N3;
        TMenuItem *Delete1;
        TCheckBox *DownloadAll;
        TComboBox *ServerBox;
        TComboBox *ProxyBox;
        TLabel *Label2;
        TProgressBar *ProgressBar;
        TButton *ServerBtn;
        TMenuItem *Opencurrent1;
        TSpeedButton *ResetBtn;
        TMenuItem *N4;
        TMenuItem *Reload1;
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall OpenNewsItemClick(TObject *Sender);
        void __fastcall GetMailBtnClick(TObject *Sender);
	void __fastcall NNTPRequestDone(TObject *Sender, TNntpRequest RqType, WORD Error);
	void __fastcall NNTPDisplay(TObject *Sender, void *Msg, int Len);
	void __fastcall NNTPSessionConnected(TObject *Sender, WORD Error);
	void __fastcall NNTPSessionClosed(TObject *Sender, WORD Error);
	void __fastcall NNTPMessageBegin(TObject *Sender);
	void __fastcall NNTPMessageEnd(TObject *Sender);
	void __fastcall NNTPMessageLine(TObject *Sender);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
        void __fastcall NNTPXHdrLine(TObject *Sender);
        void __fastcall Tools1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall SubListDrawItem(TWinControl *Control, int Index,
           TRect &Rect, TOwnerDrawState State);
        void __fastcall SubListMouseDown(TObject *Sender, TMouseButton Button,
           TShiftState Shift, int X, int Y);
        void __fastcall SubListDblClick(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall Items1Click(TObject *Sender);
        void __fastcall View1Click(TObject *Sender);
        void __fastcall Edit1Click(TObject *Sender);
        void __fastcall New1Click(TObject *Sender);
        void __fastcall Delete2Click(TObject *Sender);
        void __fastcall DownloadAllClick(TObject *Sender);
        void __fastcall ServerBoxChange(TObject *Sender);
        void __fastcall ProxyBoxDrawItem(TWinControl *Control, int Index,
           TRect &Rect, TOwnerDrawState State);
        void __fastcall ProxyBoxChange(TObject *Sender);
        void __fastcall ServerBoxDrawItem(TWinControl *Control, int Index,
           TRect &Rect, TOwnerDrawState State);
        void __fastcall Opencurrent1Click(TObject *Sender);
        void __fastcall ResetBtnClick(TObject *Sender);
        void __fastcall Reload1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
   TQSNntpCli *NNTP;
   HWND hWndQS;
   TStrings *display;
   AnsiString cap, winpos, curNewsgroup;
   double bodlines, curline, cursub, estimated;
   TStringList *subs, *usubs;
   TMemoryStream *article;
   Graphics::TBitmap *chkmail;
   bool cancel,InHead,InBody,InSubject,InMessage,connected,working, openaccounts;
   bool unattended, dogetnews, closing;
   int curmessage, curgroup, lastread, curmsg, lastavail, mails, mouseX, mouseY;
   TStringList *message,*lastmessagenum,*subjects, *proxy, *newsgroups, *groupsubjects;
   __fastcall TQSNewsWin(TComponent* Owner);
   virtual __fastcall~TQSNewsWin();
   void __fastcall NNTPRequestDoneX(TObject *Sender, TNntpRequest RqType, WORD Error);
   void __fastcall NNTPRequestDoneAll(TObject *Sender, TNntpRequest RqType, WORD Error);
   bool __fastcall NothingMarked(TStrings *profiles);
   void __fastcall SetGetBtnGlyph(bool Visible);
   void __fastcall ShowHint(TObject *Sender);
   bool __fastcall GetTheMail();
   void __fastcall DisplayMessageRetrieveRange();
   AnsiString __fastcall NewsServerCount();
   AnsiString __fastcall NewsServerNameCaption();
   AnsiString __fastcall NewsServerNameAndCountCaption();
   int  __fastcall GetNewsgroupStartMessageNum();
   int  __fastcall GetNextArticleNumber();
   void __fastcall SetLastArticle(AnsiString &okskip);
   bool __fastcall SaveMessageViaQS(HWND hWndQS, TStrings *Message);
   void __fastcall SaveMessage(TStrings *Message);
   void __fastcall SetEditRect();
   bool __fastcall ProcessAppNewsDat();
   void __fastcall SetLastLine(AnsiString msg);
   void __fastcall LoadSubList();
   void __fastcall DrawCheckBox(int x, int y, bool checked);
   //bool __fastcall NotTicked(int Index);
   void __fastcall AdjustGroupTick(const AnsiString &group);
   void __fastcall AdjustGroupTicks();
   void __fastcall SaveTick();
   void __fastcall LoadTick();
   bool __fastcall IsUserItem(int Index);
   bool __fastcall IsntGroupName(int Index);
   void __fastcall LoadProxyBox();
   // profiles
   AnsiString __fastcall ProfileName();
   AnsiString __fastcall ProfileServer();
   AnsiString __fastcall ProfileUserID();
   AnsiString __fastcall ProfilePassword();
   void __fastcall SetProfilePassword(const AnsiString &Password);
   void __fastcall SaveProfiles();

   void __fastcall GetNewsgroupSubjects(const AnsiString &newsgroup, TStrings *subjects);
   void __fastcall GetNewsgroups(TStrings *groups);
   bool __fastcall IsNewsgroupSubjectMatch(const AnsiString &newsgroup, TStrings *message);
   void __fastcall SetProfileNewsgroupLastArticleNum(const AnsiString &newsgroup, unsigned lastarticle);
   unsigned __fastcall ProfileNewsgroupLastArticleNum(const AnsiString &newsgroup);
   AnsiString __fastcall GetNextNewsgroup(int currGroup);
   bool __fastcall SubListItemChecked(int Index);
};

void __fastcall SaveNewProfiles();
extern bool SecureMode;
//---------------------------------------------------------------------------
extern TQSNewsWin *QSNewsWin;
//---------------------------------------------------------------------------
#endif
